#include <gnome.h>

#define NO 0
#define YES 1

// App scope pointers to app components
static GtkWidget* app_wnd    = NULL; // Main window 
static GtkWidget* statusbar1 = NULL; // Status bar
static GtkWidget* treeview1  = NULL; // Treeview
static GtkListStore* store   = NULL; // Tree view's store
static GtkWidget* wdgt_list[16];     // Array of main window search controls
// App scope vars
static enum{SAVE_TXT, SAVE_CSV}save_as; // File type for save file chooser
static gchar rec_loaded_text[32] = "";  // Base status bar text
// App scope state vars
static int list_store_done = NO; // Store created/populated?
static int list_cols_done  = NO; // Tree view columns added/displayed?
static int recs_initd      = NO; // Star records initialized? 

//--== Signal handler functions ==---------------------------------------------

// File|Open menu item
void
on_load_data1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
// File|Save TXT menu item
void
on_save_txt1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
// File|Save CSV menu item
void
on_save_csv1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
// File|Quit menu item
void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
// Help|About menu item
void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
// Open file chooser Cancel button
void
on_button_filech1_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data);
// Open file chooser Open button
void
on_button_filech1_open_clicked         (GtkButton       *button,
                                        gpointer         user_data);
// Main window Search Asc button
void
on_button_search_asc_clicked           (GtkButton       *button,
                                        gpointer         user_data);
// Main window Search Desc button
void
on_button_search_desc_clicked          (GtkButton       *button,
                                        gpointer         user_data);
// v1.01: Enhanced search
// Main window Magnitude check box
void
on_checkbutton_mag_released            (GtkButton       *button,
                                        gpointer         user_data);
// v1.01: Enhanced search
// Main window Period check box
void
on_checkbutton_per_released            (GtkButton       *button,
                                        gpointer         user_data);
// Main window Light Curve check box
void
on_checkbutton_spec_released               (GtkButton       *button,
                                        gpointer         user_data);
// Save file chooser Cancel button
void
on_button_filech2_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data);
// Save file chooser Save button
void
on_button_filech2_save_clicked         (GtkButton       *button,
                                        gpointer         user_data);

//--== Additional helper functions ==------------------------------------------

// Perform search
void
do_search(GtkButton* button, int asc);

// Build the list store from search results
GtkListStore*
build_list_store(int asc);

// Build column list in tree view and pop w/ data
void
add_list_columns(GtkListStore* store);

// Clear the columns to start new search
void
del_list_columns();

// Populate the widget array
void
get_widgets();

// Enable or disable a range of widgets
void
enable_widgets(int min, int max, gboolean enable);

